/*
    Proteus RPG Engine - A flexible 3D story based RPG engine.
    Copyright (C) 2002  Sam Yatchmenoff

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <windows.h>

#include <math.h>
#include "universe.h"
#include "input.h"
#include "visuals.h"
#include "party.h"
#include "milkshape.h"
#include "video.h"

void Universe::battle_init() {
}

void Universe::battle_shutdown() {
}

void Universe::battle_start()
{
	vertex3f_t party_loc;
	party.get_location(&party_loc);
	CAMERA camera;
	game_state = GS_BATTLE;
	input_set_key(I_KEY_UP, false);
	input_set_key(I_KEY_DOWN, false);
	input_set_key(I_KEY_LEFT, false);
	input_set_key(I_KEY_RIGHT, false);
	party.set_delta(NULL);
	camera.x = 100 * sin(party.get_yaw() * 0.01745f) + party_loc.x;
	camera.y = party_loc.y + 80;
	camera.z = 100 * cos(party.get_yaw() * 0.01745f) + party_loc.z;
	camera.pitch = -40.0f;
	camera.roll = 0.0f;
	camera.yaw = party.get_yaw();

	camera.y = camera.y + 200;
	video_set_camera(&camera);
}

void Universe::battle_update() {
  if (input_get_key(I_KEY_ESC) == 1) {
    printf ("Quitting..\n");
    set_game_state(GS_QUIT);		//purposeful..
  }
  battle_draw();
}

void Universe::battle_draw() {
  vertex3f_t theloc;
  party.get_location(&theloc);
  theloc.y += 95;
  
  Model *enemy;
  enemy = new Model;
  enemy->load ("modules/BASE-voyage/data/models/ghannet.ms3d");
  enemy->set_location(theloc.x, theloc.y, theloc.z);
  adventure_draw(); // <-  not what we want
}



