/*
    Proteus RPG Engine - A flexible 3D story based RPG engine.
    Copyright (C) 2002  Sam Yatchmenoff

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <windows.h>

#include "bitmap.h"
#include <string>
#include <SDL/SDL_image.h>
#include <iostream>

Bitmap::Bitmap(const string &filename, int xloc, int yloc) {
  surface = IMG_Load(filename.c_str());
  glGenTextures(1, &texture);
  glBindTexture(GL_TEXTURE_2D, texture);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
  glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, surface->w, surface->h, 0, GL_RGBA,
	       GL_UNSIGNED_BYTE, surface->pixels);
  x = xloc;
  y = yloc;
  z = 0;
}

Bitmap::~Bitmap() {
  
}

void Bitmap::render() {
  glPushMatrix();
  glLoadIdentity();
  glTranslatef(0.0f, 0.0f, -1.0f);
  glColor3f(1.0f, 1.0f, 1.0f);
  glEnable(GL_TEXTURE_2D);
  glBindTexture(GL_TEXTURE_2D, texture);
  glBegin(GL_QUADS);
  glTexCoord2f(0.0f, 0.0f);
  glVertex2f((float)(x-320)/320.0f,
	     (float)(y-240)/-240.0f);
  glTexCoord2f(0.0f, 1.0f);
  glVertex2f((float)(x-320)/320.0f,
	     (float)(surface->h-240+y)/-240.0f);
  glTexCoord2f(1.0f, 1.0f);
  glVertex2f((float)(surface->w-320+x)/320.0f,
	     (float)(surface->h-240+y)/-240.0f);
  glTexCoord2f(1.0f, 0.0f);
  glVertex2f((float)(surface->w-320+x)/320.0f,
	     (float)(y-240)/-240.0f);
  glEnd();
  glDisable(GL_TEXTURE_2D);
  glPopMatrix();
}

