/*
    Proteus RPG Engine - A flexible 3D story based RPG engine.
    Copyright (C) 2002  Sam Yatchmenoff

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef __keys_h_
#define __keys_h_

enum I_KEY {
	/* The keyboard syms have been cleverly chosen to map to ASCII */
	I_KEY_UNKNOWN			= 0,
	I_KEY_FIRST				= 0,
	I_KEY_BACKSPACE		= 8,
	I_KEY_TAB				= 9,
	I_KEY_CLEAR				= 12,
	I_KEY_RETURN			= 13,
	I_KEY_PAUSE				= 19,
	I_KEY_ESC				= 27,
	I_KEY_SPACE				= 32,
	I_KEY_EXCLAIM			= 33,
	I_KEY_QUOTEDBL			= 34,
	I_KEY_HASH				= 35,
	I_KEY_DOLLAR			= 36,
	I_KEY_AMPERSAND		= 38,
	I_KEY_QUOTE				= 39,
	I_KEY_LEFTPAREN		= 40,
	I_KEY_RIGHTPAREN		= 41,
	I_KEY_ASTERISK			= 42,
	I_KEY_PLUS				= 43,
	I_KEY_COMMA				= 44,
	I_KEY_MINUS				= 45,
	I_KEY_PERIOD			= 46,
	I_KEY_SLASH				= 47,
	I_KEY_0					= 48,
	I_KEY_1					= 49,
	I_KEY_2					= 50,
	I_KEY_3					= 51,
	I_KEY_4					= 52,
	I_KEY_5					= 53,
	I_KEY_6					= 54,
	I_KEY_7					= 55,
	I_KEY_8					= 56,
	I_KEY_9					= 57,
	I_KEY_COLON				= 58,
	I_KEY_SEMICOLON		= 59,
	I_KEY_LESS				= 60,
	I_KEY_EQUALS			= 61,
	I_KEY_GREATER			= 62,
	I_KEY_QUESTION			= 63,
	I_KEY_AT					= 64,
	/* 	
	   Skip uppercase letters
	 */
	I_KEY_LEFTBRACKET		= 91,
	I_KEY_BACKSLASH		= 92,
	I_KEY_RIGHTBRACKET	= 93,
	I_KEY_CARET				= 94,
	I_KEY_UNDERSCORE		= 95,
	I_KEY_BACKQUOTE		= 96,
	I_KEY_A					= 97,
	I_KEY_B					= 98,
	I_KEY_C					= 99,
	I_KEY_D					= 100,
	I_KEY_E					= 101,
	I_KEY_F					= 102,
	I_KEY_G					= 103,
	I_KEY_H					= 104,
	I_KEY_I					= 105,
	I_KEY_J					= 106,
	I_KEY_K					= 107,
	I_KEY_L					= 108,
	I_KEY_M					= 109,
	I_KEY_N					= 110,
	I_KEY_O					= 111,
	I_KEY_P					= 112,
	I_KEY_Q					= 113,
	I_KEY_R					= 114,
	I_KEY_S					= 115,
	I_KEY_T					= 116,
	I_KEY_U					= 117,
	I_KEY_V					= 118,
	I_KEY_W					= 119,
	I_KEY_X					= 120,
	I_KEY_Y					= 121,
	I_KEY_Z					= 122,
	I_KEY_DELETE			= 127,
	/* End of ASCII mapped keysyms */
	/* Arrows + Home/End pad */
	I_KEY_UP                 = 273,
	I_KEY_DOWN               = 274,
	I_KEY_RIGHT              = 275,
	I_KEY_LEFT               = 276,
	I_KEY_INSERT             = 277,
	I_KEY_HOME               = 278,
	I_KEY_END                = 279,
	I_KEY_PAGEUP             = 280,
	I_KEY_PAGEDOWN           = 281
};

#define I_MAXKEY 281

#endif
