/*
    Proteus RPG Engine - A flexible 3D story based RPG engine.
    Copyright (C) 2002  Sam Yatchmenoff

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "physicalobject.h"
#include <iostream>
#include <math.h>

using namespace std;

void PhysicalObject::get_location(vertex3f_t *dest) {
  dest->x = location.x;
  dest->y = location.y;
  dest->z = location.z;
}

void PhysicalObject::add_location(float x, float y, float z) {
  location.x += x;
  location.y += y;
  location.z += z;
}

void PhysicalObject::set_delta(vertex3f_t *src_delta) {
  if(src_delta == NULL) {
    delta.x = 0;
    delta.y = 0;
    delta.z = 0;
    return;
  }
  delta.x = src_delta->x;
  delta.x = src_delta->x;
  delta.x = src_delta->x;
}

void PhysicalObject::add_delta(float x, float y, float z) {
  // FINISH THIS!!!!
  float new_x, new_y, new_z;
  if(delta_rot_order == ROT_FIRST) {
    new_x = (x * cos(yaw * 3.141592654f / 180.0)) + (z * sin(yaw * 3.141592654f / 180.0));
    new_y = y;
    new_z = (z * cos(yaw * 3.141592654f / 180.0)) + (x * sin(yaw * 3.141592654f / 180.0));
   } 
   
  delta.x += new_x;
  delta.y += new_y;
  delta.z += new_z;
}

float PhysicalObject::get_pitch() {
  return pitch;
}

float PhysicalObject::get_roll() {
  return roll;
}

float PhysicalObject::get_yaw() {
  return yaw;
}

void PhysicalObject::add_yaw(float yaw_off) {
  yaw += yaw_off;
  if(yaw < 0) yaw += 360.0f;
  if(yaw >= 360.0f) yaw -= 360.0f;
}

void PhysicalObject::move(void) {
  location.x += delta.x;
  location.y += delta.y;
  location.z += delta.z;
}

void PhysicalObject::move_back(void) {
  location.x -= delta.x;
  location.y -= delta.y;
  location.z -= delta.z;
}

float PhysicalObject::get_radius() {
  return radius;
}

void PhysicalObject::set_order(int order) {
  delta_rot_order = order;
}
