/*
    Proteus RPG Engine - A flexible 3D story based RPG engine.
    Copyright (C) 2002  Sam Yatchmenoff

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <windows.h>

#include <iostream>
#include <fstream>
#include "scene.h"
#include "map.h"
#include "bsp.h"
#include "tinyxml.h"
#include "main.h"

using namespace std;

int Scene::load(const string &scene_name2) {
	string scene_name = scene_name2;

#ifdef DEBUG
	cout << "Loading scene: " << scene_name << '\n';
#endif
  
	string fullname = get_module_name() + "/scenes/" + scene_name;
	TiXmlDocument doc(fullname + "/objects.xml");
 	doc.LoadFile();

	TiXmlNode *node;

	assert(node = doc.FirstChild("List"));
	for(node = node->FirstChild("Entry"); node; node = node->NextSibling("Entry")) {
		string object_name;
 		object_name = node->FirstChild()->ToText()->Value();
#ifdef DEBUG
		cout << "object_name = " << object_name << endl;
#endif
		objects.push_back(Resource<Object>(fullname + "/objects/" + object_name + ".xml", Level));
	}
#ifdef DEBUG
	cout << get_module_name() + "/data/maps/" + scene_name + ".bsp" << endl;
#endif
	map = Resource<Map>(get_module_name() + "/data/maps/" + scene_name + ".bsp", Level);
	return 0;
}

