/*
    Proteus RPG Engine - A flexible 3D story based RPG engine.
    Copyright (C) 2002  Sam Yatchmenoff

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef __text_h_
#define __text_h_

#include <string>
#include "visual.h"

using namespace std;

int load_fonts();
void print_text(const char *text);
void print_text(int x, int y, const char *fmt, ...);

class Text : public PRVisual {
 public:
  Text(int, int, float, float, float, const char *, ...);
  void render();
 private:
  string text;
  float r, g, b;  // color
  int x, y;       // screen location; min,max are 0,640 and 0,480
};

#endif
